import { TryAgain } from "@/components/try-again"

import LoadingItem from "@/components/loading-item"
import { useGweets } from "../hooks/use-gweets"
import { InfiniteGweets } from "./infinite-gweets"

export const Comments = ({ gweetId }: { gweetId: string }) => {
    const {
        data: comments,
        isLoading,
        isError,
        fetchNextPage,
        hasNextPage,
        isFetchingNextPage,
        isSuccess,
    } = useGweets({
        queryKey: ["gweets", gweetId, "comments"],
        type: "comments",
        id: gweetId,
    })

    if (isLoading) {
        return <LoadingItem />
    }

    if (isError) {
        return <TryAgain />
    }

    return (
        <InfiniteGweets
            gweets={comments}
            fetchNextPage={fetchNextPage}
            hasNextPage={hasNextPage}
            isFetchingNextPage={isFetchingNextPage}
            isSuccess={isSuccess}
        />
    )
}